Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 698)
@@ -1112,901 +825,444 @@
 	'	   destPoints[3] <=> bottom-right corner
 
-	Function DrawImage(image As Image, destPoints As /*Const*/ PointF, count As Long) As Status
+	Sub DrawImage(image As Image, destPoints As *PointF, count As Long)
 		If count <> 3 And count <> 4 Then
-			Return SetStatus(InvalidParameter)
+			SetStatus(InvalidParameter)
 		End If
 
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
+		Dim nativeImage = getNativeImage(image)
+		SetStatus(GdipDrawImagePoints(nativeGraphics, nativeImage, destPoints, count))
+	End Sub
+
+	Sub DrawImage(image As Image, destPoints As *Point, count As Long)
+		If count <> 3 And count <> 4 Then
+			SetStatus(InvalidParameter)
 		End If
-		Return SetStatus(GdipDrawImagePoints(nativeGraphics, nativeImage, destPoints, count))
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ Point, count As Long) As Status
-		If count <> 3 And count <> 4 Then
-			Return SetStatus(InvalidParameter)
-		End If
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Return SetStatus(GdipDrawImagePointsI(nativeGraphics, nativeImage, destPoints, count))
-	End Function
-
-	Function DrawImage(image As Image, x As Single, y As Single,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Return SetStatus(GdipDrawImagePointRect(nativeGraphics, nativeImage, x, y, srcx, srcy, srcwidth, srcheight, srcUnit))
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ RectangleF,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, 0, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ RectangleF,
+
+		Dim nativeImage = getNativeImage(image)
+		SetStatus(GdipDrawImagePointsI(nativeGraphics, nativeImage, destPoints, count))
+	End Sub
+
+	Sub DrawImage(image As Image, ByRef destRect As Rectangle, ByRef src As Rectangle, srcUnit As GraphicsUnit)
+		DrawImage(image, destRect, src.X, src.Y, src.Width, src.Height, srcUnit)
+	End Sub
+
+	Sub DrawImage(image As Image, ByRef destRect As RectangleF, ByRef src As RectangleF, srcUnit As GraphicsUnit)
+		DrawImage(image, destRect, src.X, src.Y, src.Width, src.Height, srcUnit)
+	End Sub
+
+	Sub DrawImage(image As Image, x As Long, y As Long, ByRef src As Rectangle, srcUnit As GraphicsUnit)
+		Dim nativeImage = getNativeImage(image)
+		SetStatus(GdipDrawImagePointRectI(nativeGraphics, nativeImage, x, y, src.X, src.Y, src.Width, src.Height, srcUnit))
+	End Sub
+
+	Sub DrawImage(image As Image, x As Single, y As Single, ByRef src As RectangleF, srcUnit As GraphicsUnit)
+		Dim nativeImage = getNativeImage(image)
+		SetStatus(GdipDrawImagePointRect(nativeGraphics, nativeImage, x, y, src.X, src.Y, src.Width, src.Height, srcUnit))
+	End Sub
+
+	Sub DrawImage(image As Image, destPoints As *Point, count As Long, ByRef src As Rectangle, srcUnit As GraphicsUnit, _
+		imageAttr = Nothing As ImageAttributes, callback = Nothing As DrawImageAbort, callbackData = 0 As VoidPtr)
+
+		Dim nativeImage = getNativeImage(image)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		SetStatus(GdipDrawImagePointsRectI(nativeGraphics, nativeImage, destPoints, count,
+			src.X, src.Y, src.Width, src.Height, srcUnit, nativeImageAttr, callback, callbackData))
+	End Sub
+
+	Sub DrawImage(image As Image, destPoints As *PointF, count As Long, ByRef src As RectangleF, srcUnit As GraphicsUnit,
+		imageAttr = Nothing As ImageAttributes, callback = Nothing As DrawImageAbort, callbackData = 0 As VoidPtr)
+
+		Dim nativeImage = getNativeImage(image)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		SetStatus(GdipDrawImagePointsRect(nativeGraphics, nativeImage, destPoints, count,
+			src.X, src.Y, src.Width, src.Height, srcUnit, nativeImageAttr, callback, callbackData))
+	End Sub
+
+	Sub DrawImage(image As Image, ByRef destRect As RectangleF,
 		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ RectangleF,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes,
-		callback As DrawImageAbort) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, callback, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ RectangleF,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipDrawImageRectRect(nativeGraphics, nativeImageAttr,
+		imageAttr = Nothing As ImageAttributes, callback = Nothing As DrawImageAbort, callbackData = 0 As VoidPtr)
+
+		Dim nativeImage = getNativeImage(image)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		SetStatus(GdipDrawImageRectRect(nativeGraphics, nativeImageAttr,
 			destRect.X, destRect.Y, destRect.Width, destRect.Height, srcx, srcy, srcwidth, srcheight,
 			srcUnit, nativeImageAttr, callback, callbackData))
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ PointF, count As Long,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, 0, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ PointF, count As Long,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ PointF, count As Long,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes,
-		callback As DrawImageAbort) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, callback, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ PointF, count As Long,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipDrawImagePointsRect(nativeGraphics, nativeImage, destPoints, count,
-			srcx, srcy, srcwidth, srcheight, srcUnit, nativeImageAttr, callback, callbackData))
-	End Function
-
-	Function DrawImage(image As Image, x As Long, y As Long,
-		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Return SetStatus(GdipDrawImagePointRectI(nativeGraphics, nativeImage, x, y, srcx, srcy, srcwidth, srcheight, srcUnit))
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ Rectangle,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, 0, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ Rectangle,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ Rectangle,
-		srcx As Single, srcy As Single, srcwidth As Single, srcheight As Single, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort) As Status
-
-		Return DrawImage(image, destRect, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, callback, 0)
-	End Function
-
-	Function DrawImage(image As Image, destRect As /*Const*/ Rectangle,
+	End Sub
+
+	Sub DrawImage(image As Image, ByRef destRect As Rectangle,
 		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipDrawImageRectRectI(nativeGraphics, nativeImage,
+		imageAttr = Nothing As ImageAttributes, callback = Nothing As DrawImageAbort, callbackData = 0 As VoidPtr)
+
+		Dim nativeImage = getNativeImage(image)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		SetStatus(GdipDrawImageRectRectI(nativeGraphics, nativeImage,
 			destRect.X, destRect.Y, destRect.Width, destRect.Height,
 			srcx, srcy, srcwidth, srcheight, srcUnit, nativeImageAttr, callback, callbackData))
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ Point, count As Long,
-		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, 0, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ Point, count As Long,
-		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, 0, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ Point, count As Long, _
-		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit, _
-		imageAttributes As /*Const*/ ImageAttributes,
-		callback As DrawImageAbort) As Status
-
-		Return DrawImage(image, destPoints, count, srcx, srcy, srcwidth, srcheight, srcUnit, imageAttributes, callback, 0)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ Point, count As Long,
-		srcx As Long, srcy As Long, srcwidth As Long, srcheight As Long, srcUnit As GraphicsUnit,
-		imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-
-		Dim nativeImage As *GpImage
-		If VarPtr(image) <> 0 Then
-			nativeImage = image.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipDrawImagePointsRectI(nativeGraphics, nativeImage, destPoints, count,
-			srcx, srcy, srcwidth, srcheight, srcUnit, nativeImageAttr, callback, callbackData))
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *Point, count As Long, srcRect As Rectangle, srcUnit As GraphicsUnit) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *PointF, count As Long, srcRect As RectangleF, srcUnit As GraphicsUnit) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit)
-	End Function
-
-	Function DrawImage(image As Image, x As Long, y As Long, srcRect As Rectangle, srcUnit As GraphicsUnit) As Status
-		Return DrawImage(image, x, y, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit)
-	End Function
-
-	Function DrawImage(image As Image, x As Single, y As Single, srcRect As RectangleF, srcUnit As GraphicsUnit) As Status
-		Return DrawImage(image, x, y, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *Point, count As Long, srcRect As Rectangle, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *PointF, count As Long, srcRect As RectangleF, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *Point, count As Long, srcRect As Rectangle, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes, callback)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *PointF, count As Long, srcRect As RectangleF, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes, callback)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *Point, count As Long, srcRect As Rectangle, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes, callback, callbackData)
-	End Function
-
-	Function DrawImage(image As Image, destPoints As /*Const*/ *PointF, count As Long, srcRect As RectangleF, srcUnit As GraphicsUnit, imageAttributes As /*Const*/ ImageAttributes, callback As DrawImageAbort, callbackData As VoidPtr) As Status
-		Return DrawImage(image, destPoints, count, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, srcUnit, imageAttributes, callback, callbackData)
-	End Function
-
-	' The following methods are for playing an EMF+ to a graphics
-	' via the enumeration interface.  Each record of the EMF+ is
-	' sent to the callback (along with the callbackData).	Then
-	' the callback can invoke the Metafile::PlayRecord method
-	' to play the particular record.
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ PointF,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ PointF,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ PointF,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestPoint(nativeGraphics,
-			nativeImage, destPoint, callback, callbackData,nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ Point,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ Point,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoint As /*Const*/ Point,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestPointI(nativeGraphics,
-			nativeImage, destPoint, callback, callbackData,nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ RectangleF,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destRect, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ RectangleF,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destRect, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ RectangleF,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestRect(nativeGraphics,
-			nativeImage, destRect, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ Rectangle,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destRect, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ Rectangle,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destRect, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destRect As /*Const*/ Rectangle,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestRectI(nativeGraphics,
-			nativeImage, destRect, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *PointF, count As Long,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *PointF, count As Long,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *PointF, count As Long,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestPoints(nativeGraphics,
-			nativeImage,destPoints, count, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *Point, count As Long,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *Point, count As Long,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, destPoints As /*Const*/ *Point, count As Long,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileDestPointsI(nativeGraphics,
-			nativeImage,destPoints, count, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile,
-		destPoint As /*Const*/ PointF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit,
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, count, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile,
-		destPoint As /*Const*/ PointF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile,
-		destPoint As /*Const*/ PointF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit,
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestPoint(nativeGraphics, _
-			nativeImage, destPoint, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoint As /*Const*/ Point, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, count, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoint As /*Const*/ Point, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoint, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoint As /*Const*/ Point, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestPointI(nativeGraphics, _
-			nativeImage, destPoint, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ RectangleF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destRect, count, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ RectangleF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destRect, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ RectangleF, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestRect(nativeGraphics, _
-			nativeImage, destRect, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ Rectangle, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destRect, srcRect, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ Rectangle, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destRect, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destRect As /*Const*/ Rectangle, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestRectI(nativeGraphics, _
-			nativeImage, destRect, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *PointF, count As Long, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, srcRect, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *PointF, count As Long, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *PointF, count As Long, srcRect As /*Const*/ RectangleF, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestPoints(nativeGraphics, _
-			nativeImage, destPoints, count, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *Point, count As Long, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, srcRect, srcUnit, callback, 0, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *Point, count As Long, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr) As Status
-
-		Return EnumerateMetafile(metafile, destPoints, count, srcRect, srcUnit, callback, callbackData, 0)
-	End Function
-
-	Function EnumerateMetafile(metafile As /*Const*/ Metafile, _
-		destPoints As /*Const*/ *Point, count As Long, srcRect As /*Const*/ Rectangle, srcUnit As GraphicsUnit, _
-		callback As EnumerateMetafileProc, callbackData As VoidPtr, imageAttributes As /*Const*/ ImageAttributes) As Status
-
-		Dim nativeImage As /*Const*/ *GpMetafile
-		If VarPtr(metafile) <> 0 Then
-			nativeImage = metafile.NativeImage
-		Else
-			nativeImage = 0
-		End If
-		Dim nativeImageAttr As *GpImageAttributes
-		If VarPtr(imageAttributes) <> 0 Then
-			nativeImageAttr = image.NativeImageAttr
-		Else
-			nativeImageAttr = 0
-		End If
-
-		Return SetStatus(GdipEnumerateMetafileSrcRectDestPointsI(nativeGraphics, nativeImage, _
-			destPoints, count, srcRect, srcUnit, callback, callbackData, nativeImageAttr))
-	End Function
-
-	Function SetClip(g As /*Const*/ Graphics) As Status
-		Return SetClip(g, CombineMode.Replace)
-	End Function
-
-	Function SetClip(rc As /*Const*/ RectangleF) As Status
-		Return SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Replace))
-	End Function
-
-	Function SetClip(rc As /*Const*/ Rectangle) As Status
-		Return SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Replace))
-	End Function
-
-	Function SetClip(path As /*Const*/ GraphicsPath) As Status
-		Return SetStatus(GdipSetClipPath(nativeGraphics, path->nativePath, CombineMode.Replace))
-	End Function
-
-	Function SetClip(region As /*Const*/ Region) As Status
-		Return SetStatus(GdipSetClipRegion(nativeGraphics, region->nativeRegion, CombineMode.Replace))
-	End Function
-
-	Function SetClip(g As /*Const*/ Graphics, combineMode As CombineMode) As Status
-		Return SetStatus(GdipSetClipGraphics(nativeGraphics, g->nativeGraphics, combineMode))
-	End Function
-
-	Function SetClip(rc As /*Const*/ RectangleF, combineMode As CombineMode) As Status
-		Return SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, combineMode))
-	End Function
-
-	Function SetClip(rc As /*Const*/ Rectangle, combineMode As CombineMode) As Status
-		Return SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, combineMode))
-	End Function
-
-	Function SetClip(path As /*Const*/ GraphicsPath, combineMode As CombineMode) As Status
-		Return SetStatus(GdipSetClipPath(nativeGraphics, path->nativePath, combineMode))
-	End Function
-
-	Function SetClip(region As /*Const*/ Region, combineMode As CombineMode) As Status
-		Return SetStatus(GdipSetClipRegion(nativeGraphics, region->nativeRegion, combineMode))
-	End Function
-
-	' This is different than the other SetClip methods because it assumes
-	' that the HRGN is already in device units, so it doesn't transform
-	' the coordinates in the HRGN.
-
-	Function SetClip(hrgn As HRGN, combineMode As CombineMode /* = CombineModeReplace*/) As Status
-		Return SetStatus(GdipSetClipHrgn(nativeGraphics, hrgn, combineMode))
-	End Function
-
-	Function IntersectClip(rc As /*Const*/ RectangleF) As Status
-		Return SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Intersect))
-	End Function
-
-	Function IntersectClip(rc As /*Const*/ Rectangle) As Status
-		Return SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Intersect))
-	End Function
-
-	Function IntersectClip(region As /*Const*/ Region) As Status
-		Return SetStatus(GdipSetClipRegion(nativeGraphics, region->nativeRegion, CombineMode.Intersect))
-	End Function
-
-	Function ExcludeClip(rc As /*Const*/ RectangleF) As Status
-		Return SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Exclude))
-	End Function
-
-	Function ExcludeClip(rc As /*Const*/ Rectangle) As Status
-		Return SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, CombineMode.Exclude))
-	End Function
-
-	Function ExcludeClip(region As /*Const*/ Region) As Status
-		Return SetStatus(GdipSetClipRegion(nativeGraphics, region->nativeRegion, CombineMode.Exclude))
-	End Function
-
-	Function ResetClip() As Status
-		Return SetStatus(GdipResetClip(nativeGraphics))
-	End Function
-
-	Function TranslateClip(dx As Single, dy As Single) As Status
-		Return SetStatus(GdipTranslateClip(nativeGraphics, dx, dy))
-	End Function
-
-	Function TranslateClip(dx As Long, dy As Long) As Status
-		Return SetStatus(GdipTranslateClipI(nativeGraphics, dx, dy))
-	End Function
-
-	Const Function GetClip(region As Region) As Status
-		Return SetStatus(GdipGetClip(nativeGraphics, region->nativeRegion))
-	End Function
-
-	Const Function GetClipBounds(rc As RectangleF) As Status
-		Return SetStatus(GdipGetClipBounds(nativeGraphics, rc))
-	End Function
-
-	Const Function GetClipBounds(rc As Rectangle) As Status
-		Return SetStatus(GdipGetClipBoundsI(nativeGraphics, rc))
-	End Function
-
-	Const Function GetVisibleClipBounds(rc As RectangleF) As Status
-		Return SetStatus(GdipGetVisibleClipBounds(nativeGraphics, rc))
-	End Function
-
-	Const Function GetVisibleClipBounds(rc As Rectangle) As Status
-		Return SetStatus(GdipGetVisibleClipBoundsI(nativeGraphics, rc))
-	End Function
-
-	Const Function IsVisible(x As Long, y As Long) As BOOL
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, ByRef destPoint As PointF,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestPoint(nativeGraphics,
+			nativeImage, destPoint, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, ByRef destPoint As Point,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestPointI(nativeGraphics,
+			nativeImage, destPoint, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, ByRef destRect As RectangleF,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestRect(nativeGraphics,
+			nativeImage, destRect, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, ByRef destRect As Rectangle,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestRectI(nativeGraphics,
+			nativeImage, destRect, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, destPoints As *PointF, count As Long,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestPoints(nativeGraphics,
+			nativeImage,destPoints, count, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile, destPoints As *Point, count As Long,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileDestPointsI(nativeGraphics,
+			nativeImage,destPoints, count, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		ByRef destPoint As PointF, ByRef srcRect As RectangleF, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestPoint(nativeGraphics,
+			nativeImage, destPoint, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		ByRef destPoint As Point, ByRef srcRect As Rectangle, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestPointI(nativeGraphics,
+			nativeImage, destPoint, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		ByRef destRect As RectangleF, ByRef srcRect As RectangleF, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestRect(nativeGraphics,
+			nativeImage, destRect, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		ByRef destRect As Rectangle, ByRef srcRect As Rectangle, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestRectI(nativeGraphics,
+			nativeImage, destRect, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		destPoints As *PointF, count As Long, ByRef srcRect As RectangleF, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestPoints(nativeGraphics,
+			nativeImage, destPoints, count, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub EnumerateMetafile(metafile As Metafile,
+		destPoints As *Point, count As Long, ByRef srcRect As Rectangle, srcUnit As GraphicsUnit,
+		callback As EnumerateMetafileProc, callbackData = 0 As VoidPtr, imageAttr = Nothing As ImageAttributes)
+
+		Dim nativeImage = getNativeImage(metafile)
+		Dim nativeImageAttr = getNativeImageAttributes(imageAttr)
+		Dim procData As Detail.EnumerateMetafileProcData
+		procData.Proc = callback
+		procData.Data = callbackData
+		SetStatus(GdipEnumerateMetafileSrcRectDestPointsI(nativeGraphics, nativeImage,
+			destPoints, count, srcRect, srcUnit, AddressOf(Detail.NativeEnumerateMetafileProcEntry), VarPtr(procData), nativeImageAttr))
+	End Sub
+
+	Sub SetClip(g As Graphics)
+		SetClip(g, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(g As Graphics, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipGraphics(nativeGraphics, g.nativeGraphics, combineMode))
+	End Sub
+
+	Sub SetClip(ByRef rc As RectangleF)
+		SetClip(rc, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(ByRef rc As RectangleF, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, combineMode))
+	End Sub
+
+	Sub SetClip(ByRef rc As Rectangle)
+		SetClip(rc, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(ByRef rc As Rectangle, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, combineMode))
+	End Sub
+
+	Sub SetClip(path As GraphicsPath)
+		SetClip(path, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(path As GraphicsPath, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipPath(nativeGraphics, path.nativePath, combineMode))
+	End Sub
+
+	Sub SetClip(region As Region)
+		SetClip(region, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(region As Region, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipRegion(nativeGraphics, region.nativeRegion, combineMode))
+	End Sub
+
+	Sub SetClip(hrgn As HRGN)
+		SetClip(hrgn, System.Drawing.Drawing2D.CombineMode.Replace)
+	End Sub
+
+	Sub SetClip(hrgn As HRGN, combineMode As Drawing2D.CombineMode)
+		SetStatus(GdipSetClipHrgn(nativeGraphics, hrgn, combineMode))
+	End Sub
+
+	Sub IntersectClip(ByRef rc As RectangleF)
+		SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, System.Drawing.Drawing2D.CombineMode.Intersect))
+	End Sub
+
+	Sub IntersectClip(ByRef rc As Rectangle)
+		SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, System.Drawing.Drawing2D.CombineMode.Intersect))
+	End Sub
+
+	Sub IntersectClip(region As Region)
+		SetStatus(GdipSetClipRegion(nativeGraphics, region.nativeRegion, System.Drawing.Drawing2D.CombineMode.Intersect))
+	End Sub
+
+	Sub ExcludeClip(ByRef rc As RectangleF)
+		SetStatus(GdipSetClipRect(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, System.Drawing.Drawing2D.CombineMode.Exclude))
+	End Sub
+
+	Sub ExcludeClip(ByRef rc As Rectangle)
+		SetStatus(GdipSetClipRectI(nativeGraphics, rc.X, rc.Y, rc.Width, rc.Height, System.Drawing.Drawing2D.CombineMode.Exclude))
+	End Sub
+
+	Sub ExcludeClip(region As Region)
+		SetStatus(GdipSetClipRegion(nativeGraphics, region.nativeRegion, System.Drawing.Drawing2D.CombineMode.Exclude))
+	End Sub
+
+	Sub ResetClip()
+		SetStatus(GdipResetClip(nativeGraphics))
+	End Sub
+
+	Sub TranslateClip(dx As Single, dy As Single)
+		SetStatus(GdipTranslateClip(nativeGraphics, dx, dy))
+	End Sub
+
+	Sub TranslateClip(dx As Long, dy As Long)
+		SetStatus(GdipTranslateClipI(nativeGraphics, dx, dy))
+	End Sub
+
+	Const Function IsVisible(x As Long, y As Long) As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsVisiblePointI(nativeGraphics, x, y, b))
-		Return b
-	End Function
-
-	Const Function IsVisible(pt As /*Const*/ Point) As BOOL
-		Return IsVisible(pt.X, pt.Y)
-	End Function
-
-	Const Function IsVisible(x As Long, y As Long, width As Long, height As Long) As BOOL
+		IsVisible = b As Boolean
+	End Function
+
+	Const Function IsVisible(ByRef pt As Point) As Boolean
+		IsVisible(pt.X, pt.Y)
+	End Function
+
+	Const Function IsVisible(x As Long, y As Long, width As Long, height As Long) As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsVisibleRectI(nativeGraphics, x, y, width, height, b))
-		Return b
-	End Function
-
-	Const Function IsVisible(rc As /*Const*/ Rectangle) As BOOL
-		Return IsVisible(rc.X, rc.Y, rc.Width, rc.Height)
-	End Function
-
-	Const Function IsVisible(x As Single, y As Single) As BOOL
+		IsVisible = b As Boolean
+	End Function
+
+	Const Function IsVisible(ByRef rc As Rectangle) As Boolean
+		IsVisible = IsVisible(rc.X, rc.Y, rc.Width, rc.Height)
+	End Function
+
+	Const Function IsVisible(x As Single, y As Single) As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsVisiblePoint(nativeGraphics, x, y, b))
-		Return b
-	End Function
-
-	Const Function IsVisible(point As /*Const*/ PointF) As BOOL
-		Return IsVisible(pt.X, pt.Y)
-	End Function
-
-	Const Function IsVisible(x As Single, y As Single, width As Single, height As Single) As BOOL
+		IsVisible = b As Boolean
+	End Function
+
+	Const Function IsVisible(ByRef pt As PointF) As Boolean
+		IsVisible = IsVisible(pt.X, pt.Y)
+	End Function
+
+	Const Function IsVisible(x As Single, y As Single, width As Single, height As Single) As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsVisibleRect(nativeGraphics, x, y, width, height, b))
-		Return b
-	End Function
-
-	Const Function IsVisible(rect As /*Const*/ RectangleF) As BOOL
-		Return IsVisible(rc.X, rc.Y, rc.Width, rc.Height)
-	End Function
-
-	Const Function Save() As GraphicsState
-		Dim gstate As GraphicsState
-		SetStatus(GdipSaveGraphics(nativeGraphics, state))
-		Return gstate
-	End Function
-
-	Function Restore(gstate As GraphicsState)
-		Return SetStatus(GdipRestoreGraphics(nativeGraphics, gstate))
-	End Function
-
-	Function BeginContainer(dstrect As /*Const*/ RectangleF, srcrect As /*Const*/ RectangleF, unit As GraphicsUnit) As GraphicsContainer
-		Dim state As GraphicsContainer
-		SetStatus(GdipBeginContainer(nativeGraphics, dstrect, srcrect, unit, state))
-		Return state
-	End Function
-
-	Function BeginContainer(dstrect As /*Const*/ Rectangle, srcrect As /*Const*/ Rectangle, unit As GraphicsUnit) As GraphicsContainer
-		Dim state As GraphicsContainer
-		SetStatus(GdipBeginContainerI(nativeGraphics, dstrect, srcrect, unit, state))
-		Return state
-	End Function
-
-	Function BeginContainer() As GraphicsContainer
-		Dim state As GraphicsContainer
-		SetStatus(GdipBeginContainer2(nativeGraphics, state))
-		Return state
-	End Function
-
-	Function EndContainer(state As GraphicsContainer) As Status
-		Return SetStatus(GdipEndContainer(nativeGraphics, state))
-	End Function
-
-	' Only valid when recording metafiles.
-
-	Function AddMetafileComment(data As /*Const*/ *Byte, sizeData As DWord)
-		Return SetStatus(GdipComment(nativeGraphics, sizeData, data))
-	End Function
+		IsVisible = b As Boolean
+	End Function
+
+	Const Function IsVisible(ByRef rc As RectangleF) As Boolean
+		IsVisible = IsVisible(rc.X, rc.Y, rc.Width, rc.Height)
+	End Function
+
+	Const Function Save() As Drawing2D.GraphicsState
+		SetStatus(GdipSaveGraphics(nativeGraphics, Save))
+	End Function
+
+	Sub Restore(gstate As Drawing2D.GraphicsState)
+		SetStatus(GdipRestoreGraphics(nativeGraphics, gstate))
+	End Sub
+
+	Function BeginContainer(ByRef dstrect As RectangleF, ByRef srcrect As RectangleF, unit As GraphicsUnit) As Drawing2D.GraphicsContainer
+		SetStatus(GdipBeginContainer(nativeGraphics, dstrect, srcrect, unit, BeginContainer))
+	End Function
+
+	Function BeginContainer(ByRef dstrect As Rectangle, ByRef srcrect As Rectangle, unit As GraphicsUnit) As Drawing2D.GraphicsContainer
+		SetStatus(GdipBeginContainerI(nativeGraphics, dstrect, srcrect, unit, BeginContainer))
+	End Function
+
+	Function BeginContainer() As Drawing2D.GraphicsContainer
+		SetStatus(GdipBeginContainer2(nativeGraphics, BeginContainer))
+	End Function
+
+	Sub EndContainer(state As Drawing2D.GraphicsContainer)
+		SetStatus(GdipEndContainer(nativeGraphics, state))
+	End Sub
+
+	Sub AddMetafileComment(data As *Byte, sizeData As DWord)
+		SetStatus(GdipComment(nativeGraphics, sizeData, data))
+	End Sub
 
 	Static Function GetHalftonePalette() As HPALETTE
-		Return GdipCreateHalftonePalette()
-	End Function
-
-	Const Function GetLastStatus() As Status
-		Dim lastStatus = lastResult
-		lastResult = Status.Ok
-		Return lastStatus
-	End Function
+		GdipCreateHalftonePalette()
+	End Function
+
+	Function NativeGraphics() As *GpGraphics
+		NativeGraphics = nativeGraphics
+	End Function
+
+	Sub Graphics(graphics As *GpGraphics)
+		nativeGraphics = graphics
+	End Sub
 
 Private
-'	Sub Graphics(gr As Graphics)
-'		Debug
-'	End Sub
-	Sub Operator =(gr As Graphics)
-		Debug
-	End Sub
-
-Protected
-	Sub Graphics(graphics As *GpGraphics)
-		lastResult = Status.Ok
-		SetNativeGraphics(graphics)
-	End Sub
-
-	Sub SetNativeGraphics(graphics As *GpGraphics)
-		This.nativeGraphics = graphics
-	End Sub
-
-	Const Function SetStatus(status As Status) As Status
-		If status <> Status.Ok Then
-			lastResult = status
+	Static Function getNativePen(pen As Pen) As *GpPen
+		If ActiveBasic.IsNothing(pen) Then
+			getNativePen = 0
+		Else
+			getNativePen = pen.NativePen
 		End If
-		Return status
-	End Function
-
-	Const Function GetNativeGraphics() As *GpGraphics
-		Return This.nativeGraphics
-	End Function
-
-	Function GetNativePen(pen As /*Const*/ *Pen) As *GpPen
-		Return pen->nativePen
-	End Function
-
-Protected
+	End Function
+
+	Static Function getNativeStringFormat(sf As StringFormat) As *GpStringFormat
+		If ActiveBasic.IsNothing(sf) Then
+			getNativeStringFormat = 0
+		Else
+			getNativeStringFormat = sf.nativeFormat
+		End If
+	End Function
+
+	Static Function getNativeBrush(br As Brush) As *GpBrush
+		If ActiveBasic.IsNothing(br) Then
+			getNativeBrush = 0
+		Else
+			getNativeBrush = br.nativeBrush
+		End If
+	End Function
+
+	Static Function getNativeFont(font As Font) As *GpFont
+		If ActiveBasic.IsNothing(font) Then
+			getNativeFont = 0
+		Else
+			getNativeFont = font.NativeFont
+		End If
+	End Function
+
+	Static Function getNativeImage(image As Image) As *GpImage
+		If ActiveBasic.IsNothing(image) Then
+			getNativeImage = 0
+		Else
+			getNativeImage = image.nativeImage
+		End If
+	End Function
+
+	Static Function getNativeImageAttributes(imageAttr As ImageAttributes) As *GpImageAttributes
+		If ActiveBasic.IsNothing(imageAttr) Then
+			getNativeImageAttributes = 0
+		Else
+			getNativeImageAttributes = imageAttr.nativeImage
+		End If
+	End Function
+
 	nativeGraphics As *GpGraphics
-	lastResult As /*Mutable*/ Status
 End Class
 
